- Main Page
- Related Pages
- Modules
- Classes
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions

# MFnMatrixData Class Reference

# OpenMaya - API module for common classes | FunctionSet classes

Search for all occurrences

## Detailed Description

Matrix function set for dependency node data.

MFnMatrixData allows the creation and manipulation of MMatrix data objects for use in the dependency graph.

If a user written dependency node either accepts or produces MMatrix, then this class is used to extract or create the data that comes from or goes to other dependency graph nodes. The MDataHandle::type method will return kMatrix when data of this type is present. To access it, the MDataHandle::data method is used to get an MObject for the data and this should then be used to initialize an instance of MFnMatrixData.

Examples:

  cgfxAttrDef.cpp, cgfxVector.cpp, cvColorNode.cpp, dagPoseInfoCmd.cpp, GLSLShaderNode.cpp, ownerEmitter.cpp, simpleEmitter.cpp, sweptEmitter.cpp, and torusField.cpp.

`#include <MFnMatrixData.h>`

Inheritance diagram for MFnMatrixData:
[legend]

List of all members.

## Public Member Functions
virtual MFn::Type | type () const
| Function set type.
virtual | ~MFnMatrixData ()
| Destructor.
| MFnMatrixData ()
| Default constructor.
| MFnMatrixData (MObject &object, MStatus *ReturnStatus=NULL)
| Constructor.
bool | isTransformation (MStatus *ReturnStatus=NULL) const
| Determine if the matrix held in this instance is a transform matrix.
MTransformationMatrix | transformation (MStatus *ReturnStatus=NULL) const
| Return a copy of the transform matrix held in this instance.
const MMatrix & | matrix (MStatus *ReturnStatus=NULL) const
| Return a constant reference to the matrix held in this instance.
MStatus | set (const MTransformationMatrix &transformation)
| Set this instance to hold a copy of the given transform matrix.
MStatus | set (const MMatrix &matrix)
| Set this instance to hold a copy of the given matrix.
MObject | create (MStatus *ReturnStatus=NULL)
| Create a new MObject, attach it to this instance and initialize it to the identity matrix.
MObject | create (const MMatrix &, MStatus *ReturnStatus=NULL)
| Create a new MObject, attach it to this instance and initialize it to the given matrix.
MObject | create (const MTransformationMatrix &, MStatus *ReturnStatus=NULL)
| Create a new MObject, attach it to this instance and initialize it to the given transform matrix.
| MFnMatrixData (const MObject &object, MStatus *ReturnStatus=NULL)
| Constructor.
## Protected Member Functions
virtual const char * | className () const
| Class name.

## Constructor & Destructor Documentation

MFnMatrixData | ( | MObject & | object,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Constructor.

Class constructor that initializes the function set to the given MObject.

Parameters:

  [in] | object | The MObject to attach the function set to
  [out] | ReturnStatus | the return status

Status Codes:
  - MS::kSuccess if the function set is successfully attached
  - MS::kInvalidParameter if the MObject does not represent a valid Maya object or if the function set is not allowed to attach to this MObject

MFnMatrixData | ( | const MObject & | object,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Constructor.

Class constructor that initializes the function set to the given MObject.

Parameters:

  [in] | object | The MObject to attach the function set to
  [out] | ReturnStatus | the return status

Status Codes:
  - MS::kSuccess if the function set is successfully attached
  - MS::kInvalidParameter if the MObject does not represent a valid Maya object or if the function set is not allowed to attach to this MObject

## Member Function Documentation

MFn::Type type | ( |  | ) | const `[virtual]`

Search for all occurrences

Function set type.

Return the class type : MFn::kMatrixData.

Reimplemented from MFnData.

const char * className | ( |  | ) | const `[protected, virtual]`

Search for all occurrences

Class name.

Return the class name : "MFnMatrixData".

Reimplemented from MFnData.

bool isTransformation | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Determine if the matrix held in this instance is a transform matrix.

Parameters:

  [out] | ReturnStatus | kFailure if the instance is not attached to an MObject, and kSuccess otherwise.

Returns:
  true if the instance holds a transform matrix, false otherwise

MTransformationMatrix transformation | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Return a copy of the transform matrix held in this instance.

Parameters:

  [out] | ReturnStatus | kFailure if the instance is not attached to an MObject, and kSuccess otherwise.

Returns:
  A copy of the MTransformationMatrix held in this instance

const MMatrix & matrix | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Return a constant reference to the matrix held in this instance.

Parameters:

  [out] | ReturnStatus | kFailure if the instance is not attached to an MObject, and kSuccess otherwise.

Returns:
  A const reference to the MMatrix

MStatus set | ( | const MTransformationMatrix & | transformation | ) |

Search for all occurrences

Set this instance to hold a copy of the given transform matrix.

Parameters:

  [in] | transformation | the MTransformationMatrix matrix to copy the data from

Returns:
  - kSuccess operation successfull.
  - kFailure instance is not attached to an MObject

MStatus set | ( | const MMatrix & | mat | ) |

Search for all occurrences

Set this instance to hold a copy of the given matrix.

Parameters:

  [in] | mat | the MMatrix matrix to copy the data from

Returns:
  - kSuccess operation successfull.
  - kFailure instance is not attached to an MObject

MObject create | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

Create a new MObject, attach it to this instance and initialize it to the identity matrix.

The result is not a transform matrix

Parameters:

  [out] | ReturnStatus | kSuccess

Returns:
  The new MObject

Examples:
  cgfxAttrDef.cpp.

MObject create | ( | const MMatrix & | mat,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Search for all occurrences

Create a new MObject, attach it to this instance and initialize it to the given matrix.

The result is not a transform matrix.

Parameters:

  [in] | mat | the MMatrix to copy the data from
  [out] | ReturnStatus | kSuccess

Returns:
  The new MObject

MObject create | ( | const MTransformationMatrix & | transformation,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Search for all occurrences

Create a new MObject, attach it to this instance and initialize it to the given transform matrix.

Parameters:

  [in] | transformation | the MTransformationMatrix to copy the data from
  [out] | ReturnStatus | kSuccess

Returns:
  The new MObject

MFnMatrixData MFnMatrixData MFnMatrixData MFnMatrixData MFnMatrixData MFnMatrixData MFnMatrixData MFnMatrixData MFnMatrixData MFnMatrixData
MFnMatrixData MFnMatrixData MFnMatrixData MFnMatrixData MFnMatrixData MFnMatrixData MFnMatrixData MFnMatrixData MFnMatrixData MFnMatrixData